/*=======================================================================================================
                                              Чтение напряжения аккумулятора
=======================================================================================================*/
void Read_Volt() 
{
  Vcc = Read_Vcc();
  float Cur_Volt  = 0.0;
  
  for (int i = 0; i < 5; i++) 
  {
    Cur_Volt  = Cur_Volt  + analogRead(Ak);
    delay(10);
  }
  
  Cur_Volt  /= 5;
  float V    = (Cur_Volt * Vcc) / 1024.0;
  AKKU_Car   = ((V / (R2 / (R1 + R2)))) * 100;
    
  analogWrite(Ak, 0);
  delay(10);
}
/*=======================================================================================================
                                              
=======================================================================================================*/
float Read_Vcc() 
{
  float result = 0.0;
  float tmp = 0.0;

  for (byte i = 0; i < 5; i++) 
  {
    // Read 1.1V reference against AVcc
    // set the reference to Vcc and the measurement to the internal 1.1V reference
    
    #if defined(__AVR_ATmega32U4__) || defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)
        ADMUX = _BV(REFS0) | _BV(MUX4) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);
    #elif defined (__AVR_ATtiny24__) || defined(__AVR_ATtiny44__) || defined(__AVR_ATtiny84__)
        ADMUX = _BV(MUX5) | _BV(MUX0);
    #elif defined (__AVR_ATtiny25__) || defined(__AVR_ATtiny45__) || defined(__AVR_ATtiny85__)
        ADMUX = _BV(MUX3) | _BV(MUX2);
    #else
        ADMUX = _BV(REFS0) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1); // works on an Arduino 168 or 328
    #endif

    delay(3);                                                   // Wait for Vref to settle
    ADCSRA |= _BV(ADSC);                                        // Start conversion
    while (bit_is_set(ADCSRA,ADSC));                            // measuring

    uint8_t low  = ADCL;                                        // must read ADCL first - it then locks ADCH
    uint8_t high = ADCH;                                        // unlocks both

    tmp = (high<<8) | low;
    tmp = (Typ_Vbg * 1023.0) / tmp;
    result = result + tmp;
    delay(5);
  }

  result = result / 5;
  return result;
}

char * TimeToString(unsigned long t)                            // t is time in seconds = millis()/1000;
{
  static char str[12];
  long h = t / 3600;
  t = t % 3600;
  int m = t / 60;
  int s = t % 60;
  sprintf(str, "%04ld:%02d:%02d", h, m, s);
  return str;
}
/*=====================================================================================================*/
